#region Copyright Syncfusion Inc. 2001 - 2008
//
//  Copyright Syncfusion Inc. 2001 - 2008. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram.Controls;

namespace Syncfusion.Windows.Forms.Diagram.Samples
{
	/// <summary>
	/// Main application for CustomSymbol sample.
	/// </summary>
	public class MainForm : Form
	{
        #region Form controls
        private ToolBar toolBar1;
        private ToolBarButton toolBarButtonSelect;
        private ToolBarButton toolBarButtonAddSymbol;
        private ImageList imageList1;
        private PropertyEditor propertyEditor1;
        private Controls.Diagram diagram1;
        private ToolBarButton toolBarButtonClone;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Diagram.Model model1;
        private ToolBarButton toolBarButton_PropertyEditor;
        private MenuStrip menuStrip1;
        private ToolStripMenuItem fileToolStripMenuItem;
        private ToolStripMenuItem copyToolStripMenuItem;
        private ToolStripMenuItem pasteToolStripMenuItem;
        private IContainer components;

        protected MySymbol my_handler = new MySymbol();
        protected Node my_node;
		#endregion

        #region Class Initialize/Finalize methods
        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.diagram1.Model = this.model1;
            this.diagram1.View.Grid.Visible = false;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="disposing"></param>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        
        #region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.toolBarButtonSelect = new System.Windows.Forms.ToolBarButton();
            this.toolBarButtonAddSymbol = new System.Windows.Forms.ToolBarButton();
            this.toolBarButtonClone = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton_PropertyEditor = new System.Windows.Forms.ToolBarButton();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.propertyEditor1 = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor(this.components);
            this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram(this.components);
            this.model1 = new Syncfusion.Windows.Forms.Diagram.Model(this.components);
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.menuStrip1 = new System.Windows.Forms.MenuStrip();
            this.fileToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.copyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.pasteToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            ((System.ComponentModel.ISupportInitialize)(this.diagram1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).BeginInit();
            this.menuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.toolBarButtonSelect,
            this.toolBarButtonAddSymbol,
            this.toolBarButtonClone,
            this.toolBarButton_PropertyEditor});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.ImageList = this.imageList1;
            this.toolBar1.Location = new System.Drawing.Point(0, 24);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(576, 28);
            this.toolBar1.TabIndex = 0;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // toolBarButtonSelect
            // 
            this.toolBarButtonSelect.ImageIndex = 0;
            this.toolBarButtonSelect.Name = "toolBarButtonSelect";
            this.toolBarButtonSelect.ToolTipText = "Select";
            // 
            // toolBarButtonAddSymbol
            // 
            this.toolBarButtonAddSymbol.ImageIndex = 1;
            this.toolBarButtonAddSymbol.Name = "toolBarButtonAddSymbol";
            this.toolBarButtonAddSymbol.ToolTipText = "Add Symbol";
            // 
            // toolBarButtonClone
            // 
            this.toolBarButtonClone.ImageIndex = 2;
            this.toolBarButtonClone.Name = "toolBarButtonClone";
            this.toolBarButtonClone.ToolTipText = "Clone";
            // 
            // toolBarButton_PropertyEditor
            // 
            this.toolBarButton_PropertyEditor.ImageIndex = 3;
            this.toolBarButton_PropertyEditor.Name = "toolBarButton_PropertyEditor";
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "property_editor.png");
            // 
            // propertyEditor1
            // 
            this.propertyEditor1.Diagram = this.diagram1;
            this.propertyEditor1.Dock = System.Windows.Forms.DockStyle.Right;
            this.propertyEditor1.Location = new System.Drawing.Point(424, 52);
            this.propertyEditor1.Name = "propertyEditor1";
            this.propertyEditor1.Size = new System.Drawing.Size(152, 369);
            this.propertyEditor1.TabIndex = 5;
            this.propertyEditor1.Visible = false;
            // 
            // diagram1
            // 
            this.diagram1.AllowDrop = true;
            this.diagram1.Controller.PasteOffset = new System.Drawing.SizeF(10F, 10F);
            this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.diagram1.HScroll = true;
            this.diagram1.LayoutManager = null;
            this.diagram1.Location = new System.Drawing.Point(0, 52);
            this.diagram1.Model = null;
            this.diagram1.Name = "diagram1";
            this.diagram1.ScrollVirtualBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram1.ScrollVirtualBounds")));
            this.diagram1.ShowRulers = false;
            this.diagram1.Size = new System.Drawing.Size(424, 369);
            this.diagram1.SmartSizeBox = false;
            this.diagram1.TabIndex = 0;
            // 
            // 
            // 
            this.diagram1.View.Grid.HorizontalSpacing = 10F;
            this.diagram1.View.Grid.VerticalSpacing = 10F;
            this.diagram1.View.MouseTrackingEnabled = false;
            this.diagram1.View.PasteOffsetX = 0;
            this.diagram1.View.PasteOffsetY = 0;
            this.diagram1.View.ScrollVirtualBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram1.View.ScrollVirtualBounds")));
            this.diagram1.VScroll = true;
            // 
            // model1
            // 
            this.model1.BackgroundStyle.Color = System.Drawing.Color.White;
            this.model1.BackgroundStyle.PathBrushStyle = Syncfusion.Windows.Forms.Diagram.PathGradientBrushStyle.RectangleCenter;
            this.model1.CanUngroup = false;
            this.model1.LineStyle.DashPattern = null;
            this.model1.LineStyle.LineColor = System.Drawing.Color.Black;
            this.model1.LogicalSize = new System.Drawing.SizeF(827F, 1169F);
            this.model1.OptimizeLineBridging = false;
            this.model1.ShadowStyle.Color = System.Drawing.Color.DimGray;
            this.model1.ShadowStyle.ColorAlphaFactor = 255;
            this.model1.ShadowStyle.ForeColor = System.Drawing.Color.DimGray;
            this.model1.ShadowStyle.ForeColorAlphaFactor = 255;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
            this.splitter1.Location = new System.Drawing.Point(421, 52);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 369);
            this.splitter1.TabIndex = 6;
            this.splitter1.TabStop = false;
            // 
            // menuStrip1
            // 
            this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.fileToolStripMenuItem});
            this.menuStrip1.Location = new System.Drawing.Point(0, 0);
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size(576, 24);
            this.menuStrip1.TabIndex = 7;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // fileToolStripMenuItem
            // 
            this.fileToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.copyToolStripMenuItem,
            this.pasteToolStripMenuItem});
            this.fileToolStripMenuItem.Name = "fileToolStripMenuItem";
            this.fileToolStripMenuItem.Size = new System.Drawing.Size(37, 20);
            this.fileToolStripMenuItem.Text = "File";
            // 
            // copyToolStripMenuItem
            // 
            this.copyToolStripMenuItem.Name = "copyToolStripMenuItem";
            this.copyToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
            this.copyToolStripMenuItem.Text = "Copy";
            this.copyToolStripMenuItem.Click += new System.EventHandler(this.copyToolStripMenuItem_Click);
            // 
            // pasteToolStripMenuItem
            // 
            this.pasteToolStripMenuItem.Name = "pasteToolStripMenuItem";
            this.pasteToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
            this.pasteToolStripMenuItem.Text = "Paste";
            this.pasteToolStripMenuItem.Click += new System.EventHandler(this.pasteToolStripMenuItem_Click);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(576, 421);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.diagram1);
            this.Controls.Add(this.propertyEditor1);
            this.Controls.Add(this.toolBar1);
            this.Controls.Add(this.menuStrip1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MainMenuStrip = this.menuStrip1;
            this.Name = "MainForm";
            this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Custom Symbol Sample";
            this.Load += new System.EventHandler(this.MainForm_Load);
            ((System.ComponentModel.ISupportInitialize)(this.diagram1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).EndInit();
            this.menuStrip1.ResumeLayout(false);
            this.menuStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		#endregion
        
        #region MAIN
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new MainForm());
        }
        #endregion

        #region Class helper methods
		/// <summary>
        /// Activate tool on specific button press.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolBar1_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if (e.Button == this.toolBarButtonAddSymbol)
            {
                MySymbol symb = new MySymbol();
                this.diagram1.Model.AppendChild(symb);                
            }
            else if ((e.Button == this.toolBarButtonClone) && (this.diagram1.View.SelectionList.Count > 0))
            {
                Group selectedSymbol = this.diagram1.View.SelectionList[0] as Group;

                if (selectedSymbol != null)
                {
                    Group symbolClone = (Group)selectedSymbol.Clone();
                    symbolClone.Translate(5, 5);
                    this.diagram1.Model.AppendChild(symbolClone);
                }
            }
            else if (e.Button == this.toolBarButton_PropertyEditor )
                this.propertyEditor1.Visible = !this.propertyEditor1.Visible;

            diagram1.Focus();
        }
		#endregion

        private void MainForm_Load(object sender, EventArgs e)
        {
            #region PropertyEditor Color Settings
            this.propertyEditor1.PropertyGrid.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(227)), ((System.Byte)(239)), ((System.Byte)(255)));
            this.propertyEditor1.PropertyGrid.CommandsBackColor = System.Drawing.Color.FromArgb(((System.Byte)(227)), ((System.Byte)(239)), ((System.Byte)(255)));
            this.propertyEditor1.PropertyGrid.CommandsForeColor = System.Drawing.Color.MidnightBlue;
            this.propertyEditor1.PropertyGrid.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.propertyEditor1.PropertyGrid.HelpBackColor = System.Drawing.Color.FromArgb(((System.Byte)(227)), ((System.Byte)(239)), ((System.Byte)(255)));
            this.propertyEditor1.PropertyGrid.HelpForeColor = System.Drawing.Color.MidnightBlue;
            this.propertyEditor1.PropertyGrid.LineColor = System.Drawing.Color.FromArgb(((System.Byte)(185)), ((System.Byte)(216)), ((System.Byte)(255)));
            this.propertyEditor1.PropertyGrid.ViewBackColor = System.Drawing.Color.FromArgb(((System.Byte)(227)), ((System.Byte)(239)), ((System.Byte)(255)));
            this.propertyEditor1.PropertyGrid.ViewForeColor = System.Drawing.Color.MidnightBlue;
            #endregion
            //
            //Event for handling Size change
            //
            this.diagram1.Model.EventSink.SizeChanged += new SizeChangedEventHandler(EventSink_SizeChanged);                        
        }

        void EventSink_SizeChanged(SizeChangedEventArgs evtArgs)
        {
            //Node m_node = evtArgs.NodeAffected as Node;
            //my_node = my_handler.GetChildByName("Polygon");
            if (evtArgs.NodeAffected.FullName.StartsWith("Model.MySymbol"))// == my_node)// my_handler.GetChildByName("Polygon"))
            {
                if(evtArgs.NodeAffected is Polygon)
                //Group grp = evtArgs.NodeAffected as Group;
                //if(evtArgs.NodeAffected == grp.GetChildByName("Polygon"))
                //Node m_node = (Node)evtArgs.NodeAffected as Node;
                //my_node = my_handler.GetChildByName("Polygon");
                //if(m_node.Name == my_node.Name)
                    MessageBox.Show("Hey");
            }

        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.diagram1.Copy();
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.diagram1.Paste();
        }
	}
}